## gfal2 2.2.1

=== CMakeLists.txt ===
## cmake build script for srm-ifce
project (gfal2)
cmake_minimum_required (VERSION 2.6)
message("cmake source dir : ${CMAKE_SOURCE_DIR}")
# default set of options
SET(MAIN_CORE TRUE
        CACHE STRING "enable compilation of the main library")
SET(PLUGIN_LFC TRUE
        CACHE STRING "enable compilation of the lfc plugin")
SET(PLUGIN_SRM TRUE
        CACHE STRING "enable compilation of the srm plugin")
SET(PLUGIN_RFIO TRUE
        CACHE STRING "enable compilation of the RFIO plugin")
SET(PLUGIN_DCAP TRUE
        CACHE STRING "enable compilation of the DCAP plugin")
SET(PLUGIN_FILE TRUE
        CACHE STRING "enable compilation of the local File plugin")
SET(PLUGIN_GRIDFTP TRUE
        CACHE STRING "enable compilation of the GRIDFTP plugin")
SET(PLUGIN_HTTP FALSE
        CACHE STRING "enable compilation of the HTTP plugin")

SET(MAIN_TRANSFER TRUE
        CACHE STRING "enable compilation of the transfer library")

# build type
set(CMAKE_BUILD_TYPE "RelWithDebInfo"
	CACHE STRING "type of build")

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules/")
# load module
include(DefineInstallationPaths REQUIRED)
include(MacroCopyFile REQUIRED)
include(ReleaseDebugAutoFlags REQUIRED)
include(CMakeGeneratePkgConfig REQUIRED)
include(MacroAddDoxygen REQUIRED)

find_package(PkgConfig REQUIRED)

#enable testing
INCLUDE(CTest)

#define PROJECT vars
set(PROJECT_NAME_MAIN "gfal2")
set(OUTPUT_NAME_MAIN "gfal2")

set(PROJECT_NAME_TRANSFER "gfal_transfer")
set(OUTPUT_NAME_TRANSFER "gfal_transfer")

set(PROJECT_NAME_LFC "plugin_lfc")
set(OUTPUT_NAME_LFC "gfal_plugin_lfc")

set(PROJECT_NAME_SRM "plugin_srm")
set(OUTPUT_NAME_SRM "gfal_plugin_srm")

set(PROJECT_NAME_RFIO "plugin_rfio")
set(OUTPUT_NAME_RFIO "gfal_plugin_rfio")

set(PROJECT_NAME_DCAP "plugin_dcap")
set(OUTPUT_NAME_DCAP "gfal_plugin_dcap")

set(PROJECT_NAME_GRIDFTP "plugin_gridftp")
set(OUTPUT_NAME_GRIDFTP "gfal_plugin_gridftp")

set(PROJECT_NAME_FILE "plugin_file")
set(OUTPUT_NAME_FILE "gfal_plugin_file")

set(PROJECT_NAME_HTTP "plugin_http")
set(OUTPUT_NAME_HTTP "gfal_plugin_http")

set(VERSION_MAJOR  2)
set(VERSION_MINOR  2)
set(VERSION_PATCH 0)
set(VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})


# out of project test compilation
SET(ONLY_TESTS FALSE
	CACHE STRING "enable or disable out of project dir")


# libs checks
pkg_check_modules(GLIB2_PKG REQUIRED glib-2.0)
pkg_check_modules(GTHREAD2_PKG REQUIRED gthread-2.0)
pkg_check_modules(UUID_PKG REQUIRED uuid)
pkg_search_module(GLIBMM_PKG REQUIRED glibmm glibmm-2.6 glibmm-2.4)

IF(PLUGIN_SRM)
pkg_check_modules(SRM_IFCE_PKG REQUIRED srm-ifce>=1.15.0)
ENDIF(PLUGIN_SRM)

IF(PLUGIN_HTTP)
pkg_check_modules(GSOAP_SSL_PKG REQUIRED "gsoapssl++")
pkg_check_modules(DAVIX_PKG REQUIRED "davix>=0.0.20")
find_package(gSOAP REQUIRED)
ENDIF(PLUGIN_HTTP)

IF(PLUGIN_GRIDFTP)
pkg_check_modules(GLOBUS_GASS_COPY_PKG REQUIRED globus-gass-copy)
ENDIF(PLUGIN_GRIDFTP)


# general parameters for configuration
add_definitions( -DGFAL_PLUGIN_DIR_DEFAULT="${PLUGIN_INSTALL_DIR}" )
add_definitions( -DGFAL_CONFIG_DIR_DEFAULT="${SYSCONF_INSTALL_DIR}" )
# add file offset 64 for 32 bits
add_definitions( -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -D_GNU_SOURCE)

include_directories( ${GLIB2_PKG_INCLUDE_DIRS} ${GTHREAD2_PKG_INCLUDE_DIRS})


#install doc license
install(FILES "LICENSE" "README" "RELEASE-NOTES" "VERSION" "DESCRIPTION"
			DESTINATION ${DOC_INSTALL_DIR})
			
# install configuration files
FILE(GLOB lst_conf_files "${CMAKE_SOURCE_DIR}/dist/etc/gfal2.d/*.conf")
install(FILES ${lst_conf_files}
			DESTINATION ${SYSCONF_INSTALL_DIR}/gfal2.d/)

IF(NOT ONLY_TESTS)
	add_subdirectory (doc)
	add_subdirectory (src)
ENDIF(NOT ONLY_TESTS)



add_subdirectory (test)
add_subdirectory (testing)

=== src/CMakeLists.txt ===
## default set of build

	
SET(IS_IFCE FALSE)
# subdir import
add_subdirectory(global)
add_subdirectory(config)
add_subdirectory(file)
add_subdirectory(cancel)
add_subdirectory(externals/utils)
add_subdirectory(externals/g_config_manager)
add_subdirectory(fdesc)

## defaults sources
FILE(GLOB src_posix "posix/*.c")
FILE(GLOB src_common "common/*.c")
FILE(GLOB src_gsimplecache "externals/gsimplecache/*.c")
#version sources
FILE(GLOB src_version "version/*.c")
#define lfc sources
FILE(GLOB src_lfc "common/lfc/*.c")
#define srm sources
FILE(GLOB src_srm "common/srm/*.c")
#define rfio sources
FILE(GLOB src_rfio "common/rfio/*.c")
#define dcap sources
FILE(GLOB src_dcap "common/dcap/*.c")
#define libcpp source
FILE(GLOB src_libcpp "libcpp/*.cpp")
#define logger source
FILE(GLOB src_logger "logger/*.c")
#define exceptions source
FILE(GLOB src_exceptions "exceptions/*.cpp")

# global headers
SET(common_dir	"common/")
SET(posix_dir	"posix/")
SET(mds_dir	"common/mds/")
SET(global_dir	".")
SET(externals_dir	"externals/")


# gfal2 link and link dir
SET(gfal2_link "gfal2")

LIST(APPEND headers_main ${common_dir} ${posix_dir} ${global_dir} 
			${mds_dir}  ${externals_dir})

include_directories(${headers_main} )
add_definitions( -DVERSION="${VERSION_STRING}" -Wall ${GLIB2_PKG_CFLAGS} ${GTHREAD2_PKG_CFLAGS})


LIST(APPEND main_libs ${src_posix} ${src_common} ${src_global} ${src_config}
          ${src_uri} ${src_logger} ${src_g_shared_map}
         ${src_file} ${src_cancel})


IF (MAIN_CORE)

	add_library(gfal2  SHARED ${main_libs} )
        target_link_libraries(gfal2	${UUID_PKG_LIBRARIES} "stdc++" ) # hotfix for libc TLS init bug in EPEL 5
	target_link_libraries(gfal2 ${GLIB2_PKG_LIBRARIES} ${GTHREAD2_PKG_LIBRARIES} 
                                                          "dl" )
	set_target_properties(gfal2	 	PROPERTIES
									VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}
									SOVERSION ${VERSION_MAJOR}
									CLEAN_DIRECT_OUTPUT 1
									OUTPUT_NAME ${OUTPUT_NAME_MAIN}
	)
	add_PkgConfigFile_for_Library("gfal2.pc" gfal2 
										HEADER_DIRS "gfal2"
										DESCRIPTION "GFAL 2.0 pkgconfig file"
										REQUIRES "glib-2.0")	
	add_executable(gfal2_version ${src_version})
	target_link_libraries(gfal2_version "gfal2")


	install(TARGETS gfal2 gfal2_version
			RUNTIME       DESTINATION ${BIN_INSTALL_DIR}
			LIBRARY       DESTINATION ${LIB_INSTALL_DIR} )
			
	install(FILES ${CMAKE_CURRENT_BINARY_DIR}/gfal2.pc DESTINATION ${PKGCONFIG_FILES_DIR})

	install(FILES "gfal_api.h" "gfal_plugins_api.h"
			DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/ ) # install headers main

	install(FILES "logger/gfal_logger.h"
			DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/logger ) # install headers posix

	install(FILES "posix/gfal_posix_api.h"
			DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/posix ) # install headers posix

	install(FILES   "common/gfal_constants.h"
					"common/gfal_common_plugin_interface.h" 
					"common/gfal_prototypes.h"
					"common/gfal_common_plugin.h"
                    "common/gfal_types.h"
			DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/common ) # install headers common

	FILE(GLOB l_examples "../testing/example/*.c")
	install(FILES ${l_examples}
			DESTINATION ${DOC_INSTALL_DIR}/examples/ ) # install examples 
			
	install(FILES 	"global/gfal_global.h"
			DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/global)

    install(FILES "externals/g_config_manager/g_config_manager.h"
            DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/g_config_manager)

ENDIF (MAIN_CORE)



IF(PLUGIN_LFC)

find_package(LFC REQUIRED)
find_package(DPM REQUIRED)


# lfc headers
SET(lfc_dir "common/lfc/")
SET(lfc_headers_dir "${LFC_INCLUDE}/lfc/")
#lcgdm headers
SET(lcgdm_headers_dir "${DPM_INCLUDE}/lcgdm/")

add_definitions( -D_REENTRANT)
add_library(plugin_lfc  SHARED ${src_lfc} ${src_gsimplecache})

target_link_libraries(plugin_lfc ${gfal2_link} ${LFC_LIBRARIES} ${UUID_PKG_LIBRARIES} )
include_directories(${LFC_INCLUDE_DIR} ${LCGDM_INCLUDE_DIR} ${UUID_PKG_INCLUDE_DIR})


set_target_properties(plugin_lfc	 	PROPERTIES
								CLEAN_DIRECT_OUTPUT 1
								OUTPUT_NAME ${OUTPUT_NAME_LFC}
								LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/plugins
)

install(TARGETS		plugin_lfc
	    LIBRARY		DESTINATION ${PLUGIN_INSTALL_DIR} )

install(FILES  "common/lfc/README_PLUGIN_LFC"
		DESTINATION ${DOC_INSTALL_DIR})	
	    
ENDIF(PLUGIN_LFC)


IF(PLUGIN_SRM)


## link to internal bdii system if IS_IFCE=false else to the is_interface
IF (IS_IFCE)

        SET(is_ifce_link	"is_ifce")
        add_definitions(-DMDS_BDII_EXTERNAL=1)
        SET(mds_source "common/mds/gfal_common_mds.c")

ELSE (IS_IFCE)
        add_definitions(-DMDS_BDII_EXTERNAL=0)
        FILE(GLOB mds_source "common/mds/*.c")
        SET(is_ifce_link	"ldap_r")

ENDIF(IS_IFCE)


add_definitions( ${SRM_IFCE_PKG_CFLAGS} )
include_directories( ${SRM_IFCE_PKG_INCLUDE_DIR} ${is_ifce_link})

add_library(plugin_srm  SHARED ${src_srm} ${src_gsimplecache} ${src_uri}  ${mds_source} )
target_link_libraries(plugin_srm ${gfal2_link} ${SRM_IFCE_PKG_LIBRARIES} ${is_ifce_link} gomp gfal2_transfer)


set_target_properties(plugin_srm	 	PROPERTIES
								CLEAN_DIRECT_OUTPUT 1
								OUTPUT_NAME ${OUTPUT_NAME_SRM}
                                                                LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/plugins
)

install(TARGETS		plugin_srm
	    LIBRARY		DESTINATION ${PLUGIN_INSTALL_DIR} )

install(FILES  "common/srm/README_PLUGIN_SRM"
		DESTINATION ${DOC_INSTALL_DIR})	

ENDIF(PLUGIN_SRM)


IF(PLUGIN_RFIO)

find_package(DPM REQUIRED)

add_library(plugin_rfio  SHARED ${src_rfio} ${src_gsimplecache} )

target_link_libraries(plugin_rfio ${gfal2_link} ${DPM_LIBRARIES} )
include_directories( ${DPM_INCLUDE_DIR} )
add_definitions( ${DPM_CFLAGS} )

set_target_properties(plugin_rfio	 	PROPERTIES
								CLEAN_DIRECT_OUTPUT 1
								OUTPUT_NAME ${OUTPUT_NAME_RFIO}
								LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/plugins								
)

install(TARGETS		plugin_rfio
	    LIBRARY		DESTINATION ${PLUGIN_INSTALL_DIR} )
  	
install(FILES  "common/rfio/README_PLUGIN_RFIO"
		DESTINATION ${DOC_INSTALL_DIR})	
		
ENDIF(PLUGIN_RFIO)



IF(PLUGIN_DCAP)

find_package(DCAP REQUIRED)

add_definitions( -D_REENTRANT)
add_library(plugin_dcap  SHARED ${src_dcap} ${src_gsimplecache} )

target_link_libraries(plugin_dcap ${gfal2_link} ${DCAP_LIBRARIES})
include_directories( ${DCAP_INCLUDE_DIR} )
add_definitions( ${DCAP_CFLAGS} )

set_target_properties(plugin_dcap	 	PROPERTIES
								CLEAN_DIRECT_OUTPUT 1
								OUTPUT_NAME ${OUTPUT_NAME_DCAP}
								LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/plugins								
)

install(TARGETS		plugin_dcap
	    LIBRARY		DESTINATION ${PLUGIN_INSTALL_DIR} )

install(FILES  "common/dcap/README_PLUGIN_DCAP"
		DESTINATION ${DOC_INSTALL_DIR})	

ENDIF(PLUGIN_DCAP)




add_subdirectory(common/http)


add_subdirectory(transfer)                         
add_subdirectory(common/gridftp)    
add_subdirectory(common/file)

=== test/gtest-1.6.0/CMakeLists.txt ===
########################################################################
# CMake build script for Google Test.
#
# To run the tests for Google Test itself on Linux, use 'make test' or
# ctest.  You can select which tests to run using 'ctest -R regex'.
# For more options, run 'ctest --help'.

# BUILD_SHARED_LIBS is a standard CMake variable, but we declare it here to
# make it prominent in the GUI.
SET(BUILD_SHARED_LIBS OFF
	CACHE STRING "Build shared libraries (DLLs)." FORCE)

# When other libraries are using a shared version of runtime libraries,
# Google Test also has to use one.
option(
  gtest_force_shared_crt
  "Use shared (DLL) run-time lib even when Google Test is built as static lib."
  OFF)

option(gtest_build_tests "Build all of gtest's own tests." OFF)

option(gtest_build_samples "Build gtest's sample programs." OFF)

option(gtest_disable_pthreads "Disable uses of pthreads in gtest." OFF)

# Defines pre_project_set_up_hermetic_build() and set_up_hermetic_build().
include(cmake/hermetic_build.cmake OPTIONAL)

if (COMMAND pre_project_set_up_hermetic_build)
  pre_project_set_up_hermetic_build()
endif()

# disable warnings
set(CMAKE_CXX_FLAGS_DEBUG  "-g   -fstack-protector-all ")
set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "  -g -O2")

########################################################################
#
# Project-wide settings

# Name of the project.
#
# CMake files in this project can refer to the root source directory
# as ${gtest_SOURCE_DIR} and to the root binary directory as
# ${gtest_BINARY_DIR}.
# Language "C" is required for find_package(Threads).
project(gtest CXX C)
cmake_minimum_required(VERSION 2.6.2)


if (COMMAND set_up_hermetic_build)
  set_up_hermetic_build()
endif()

# Define helper functions and macros used by Google Test.
include(cmake/internal_utils.cmake)

config_compiler_and_linker()  # Defined in internal_utils.cmake.

# Where Google Test's .h files can be found.
include_directories(
  ${gtest_SOURCE_DIR}/include
  ${gtest_SOURCE_DIR})

# Where Google Test's libraries can be found.
link_directories(${gtest_BINARY_DIR}/src)

########################################################################
#
# Defines the gtest & gtest_main libraries.  User tests should link
# with one of them.

# Google Test libraries.  We build them using more strict warnings than what
# are used for other targets, to ensure that gtest can be compiled by a user
# aggressive about warnings.
cxx_library(gtest "${cxx_strict}" src/gtest-all.cc)
cxx_library(gtest_main "${cxx_strict}" src/gtest_main.cc)
target_link_libraries(gtest_main gtest)

########################################################################
#
# Samples on how to link user tests with gtest or gtest_main.
#
# They are not built by default.  To build them, set the
# gtest_build_samples option to ON.  You can do it by running ccmake
# or specifying the -Dbuild_gtest_samples=ON flag when running cmake.

if (gtest_build_samples)
  cxx_executable(sample1_unittest samples gtest_main samples/sample1.cc)
  cxx_executable(sample2_unittest samples gtest_main samples/sample2.cc)
  cxx_executable(sample3_unittest samples gtest_main)
  cxx_executable(sample4_unittest samples gtest_main samples/sample4.cc)
  cxx_executable(sample5_unittest samples gtest_main samples/sample1.cc)
  cxx_executable(sample6_unittest samples gtest_main)
  cxx_executable(sample7_unittest samples gtest_main)
  cxx_executable(sample8_unittest samples gtest_main)
  cxx_executable(sample9_unittest samples gtest)
  cxx_executable(sample10_unittest samples gtest)
endif()

########################################################################
#
# Google Test's own tests.
#
# You can skip this section if you aren't interested in testing
# Google Test itself.
#
# The tests are not built by default.  To build them, set the
# gtest_build_tests option to ON.  You can do it by running ccmake
# or specifying the -Dgtest_build_tests=ON flag when running cmake.

if (gtest_build_tests)
  # This must be set in the root directory for the tests to be run by
  # 'make test' or ctest.
  enable_testing()

  ############################################################
  # C++ tests built with standard compiler flags.

  cxx_test(gtest-death-test_test gtest_main)
  cxx_test(gtest_environment_test gtest)
  cxx_test(gtest-filepath_test gtest_main)
  cxx_test(gtest-linked_ptr_test gtest_main)
  cxx_test(gtest-listener_test gtest_main)
  cxx_test(gtest_main_unittest gtest_main)
  cxx_test(gtest-message_test gtest_main)
  cxx_test(gtest_no_test_unittest gtest)
  cxx_test(gtest-options_test gtest_main)
  cxx_test(gtest-param-test_test gtest
    test/gtest-param-test2_test.cc)
  cxx_test(gtest-port_test gtest_main)
  cxx_test(gtest_pred_impl_unittest gtest_main)
  cxx_test(gtest-printers_test gtest_main)
  cxx_test(gtest_prod_test gtest_main
    test/production.cc)
  cxx_test(gtest_repeat_test gtest)
  cxx_test(gtest_sole_header_test gtest_main)
  cxx_test(gtest_stress_test gtest)
  cxx_test(gtest-test-part_test gtest_main)
  cxx_test(gtest_throw_on_failure_ex_test gtest)
  cxx_test(gtest-typed-test_test gtest_main
    test/gtest-typed-test2_test.cc)
  cxx_test(gtest_unittest gtest_main)
  cxx_test(gtest-unittest-api_test gtest)

  ############################################################
  # C++ tests built with non-standard compiler flags.

  cxx_library(gtest_no_exception "${cxx_no_exception}"
    src/gtest-all.cc)
  cxx_library(gtest_main_no_exception "${cxx_no_exception}"
    src/gtest-all.cc src/gtest_main.cc)
  cxx_library(gtest_main_no_rtti "${cxx_no_rtti}"
    src/gtest-all.cc src/gtest_main.cc)

  cxx_test_with_flags(gtest-death-test_ex_nocatch_test
    "${cxx_exception} -DGTEST_ENABLE_CATCH_EXCEPTIONS_=0"
    gtest test/gtest-death-test_ex_test.cc)
  cxx_test_with_flags(gtest-death-test_ex_catch_test
    "${cxx_exception} -DGTEST_ENABLE_CATCH_EXCEPTIONS_=1"
    gtest test/gtest-death-test_ex_test.cc)

  cxx_test_with_flags(gtest_no_rtti_unittest "${cxx_no_rtti}"
    gtest_main_no_rtti test/gtest_unittest.cc)

  cxx_shared_library(gtest_dll "${cxx_default}"
    src/gtest-all.cc src/gtest_main.cc)

  cxx_executable_with_flags(gtest_dll_test_ "${cxx_default}"
    gtest_dll test/gtest_all_test.cc)
  set_target_properties(gtest_dll_test_
                        PROPERTIES
                        COMPILE_DEFINITIONS "GTEST_LINKED_AS_SHARED_LIBRARY=1")

  if (NOT MSVC OR NOT MSVC_VERSION EQUAL 1600)
    # The C++ Standard specifies tuple_element<int, class>.
    # Yet MSVC 10's <utility> declares tuple_element<size_t, class>.
    # That declaration conflicts with our own standard-conforming
    # tuple implementation.  Therefore using our own tuple with
    # MSVC 10 doesn't compile.
    cxx_library(gtest_main_use_own_tuple "${cxx_use_own_tuple}"
      src/gtest-all.cc src/gtest_main.cc)

    cxx_test_with_flags(gtest-tuple_test "${cxx_use_own_tuple}"
      gtest_main_use_own_tuple test/gtest-tuple_test.cc)

    cxx_test_with_flags(gtest_use_own_tuple_test "${cxx_use_own_tuple}"
      gtest_main_use_own_tuple
      test/gtest-param-test_test.cc test/gtest-param-test2_test.cc)
  endif()

  ############################################################
  # Python tests.

  cxx_executable(gtest_break_on_failure_unittest_ test gtest)
  py_test(gtest_break_on_failure_unittest)

  cxx_executable_with_flags(
    gtest_catch_exceptions_no_ex_test_
    "${cxx_no_exception}"
    gtest_main_no_exception
    test/gtest_catch_exceptions_test_.cc)
  cxx_executable_with_flags(
    gtest_catch_exceptions_ex_test_
    "${cxx_exception}"
    gtest_main
    test/gtest_catch_exceptions_test_.cc)
  py_test(gtest_catch_exceptions_test)

  cxx_executable(gtest_color_test_ test gtest)
  py_test(gtest_color_test)

  cxx_executable(gtest_env_var_test_ test gtest)
  py_test(gtest_env_var_test)

  cxx_executable(gtest_filter_unittest_ test gtest)
  py_test(gtest_filter_unittest)

  cxx_executable(gtest_help_test_ test gtest_main)
  py_test(gtest_help_test)

  cxx_executable(gtest_list_tests_unittest_ test gtest)
  py_test(gtest_list_tests_unittest)

  cxx_executable(gtest_output_test_ test gtest)
  py_test(gtest_output_test)

  cxx_executable(gtest_shuffle_test_ test gtest)
  py_test(gtest_shuffle_test)

  cxx_executable(gtest_throw_on_failure_test_ test gtest_no_exception)
  set_target_properties(gtest_throw_on_failure_test_
    PROPERTIES
    COMPILE_FLAGS "${cxx_no_exception}")
  py_test(gtest_throw_on_failure_test)

  cxx_executable(gtest_uninitialized_test_ test gtest)
  py_test(gtest_uninitialized_test)

  cxx_executable(gtest_xml_outfile1_test_ test gtest_main)
  cxx_executable(gtest_xml_outfile2_test_ test gtest_main)
  py_test(gtest_xml_outfiles_test)

  cxx_executable(gtest_xml_output_unittest_ test gtest)
  py_test(gtest_xml_output_unittest)
endif()

=== src/common/http/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

IF(PLUGIN_HTTP)

include     (CheckLibraryExists)

FILE(GLOB src_http "*.cpp")

message(STATUS "Using gsoapssl flags ${GSOAP_SSL_PKG_CFLAGS}")

# Defaults
if (NOT DEFINED DELEGATION_WSDL)
  set (DELEGATION_WSDL "${CMAKE_CURRENT_SOURCE_DIR}/delegation-1.1.0.wsdl")
endif (NOT DEFINED DELEGATION_WSDL)

# Compile the WSDL
add_custom_command (OUTPUT typemap.dat
                    COMMAND cp ${CMAKE_CURRENT_SOURCE_DIR}/typemap.dat ${CMAKE_CURRENT_BINARY_DIR}/typemap.dat)
add_custom_command (OUTPUT delegation.h
                    COMMAND ${GSOAP_WSDL2H} -I/usr/share/gsoap/import/ -o${CMAKE_CURRENT_BINARY_DIR}/delegation.h ${DELEGATION_WSDL}
                    DEPENDS typemap.dat)
add_custom_command (OUTPUT soapC.cpp soapClient.cpp
                    COMMAND ${GSOAP_SOAPCPP2} -I/usr/share/gsoap/import/ ${CMAKE_CURRENT_BINARY_DIR}/delegation.h
                    DEPENDS delegation.h)

# Includes
include_directories (${CMAKE_CURRENT_BINARY_DIR} ${GRIDSITE_INCLUDE_DIR}
                     ${GSOAP_INCLUDE_DIR})

include_directories(${DAVIX_PKG_INCLUDE_DIRS})

# link
link_directories( ${DAVIX_PKG_LIBRARY_DIRS})

add_definitions(${GSOAP_SSL_PKG_CFLAGS})

add_library     (plugin_http SHARED ${src_http}
                                    ${src_gsimplecache}
                                    ${CMAKE_CURRENT_BINARY_DIR}/soapC.cpp
                                    ${CMAKE_CURRENT_BINARY_DIR}/soapClient.cpp)

target_link_libraries(plugin_http ${gfal2_link} ${DAVIX_PKG_LIBRARIES} gsoapssl++ gridsite)


set_target_properties(plugin_http   PROPERTIES  CLEAN_DIRECT_OUTPUT 1
                                                OUTPUT_NAME ${OUTPUT_NAME_HTTP}
                                                LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/plugins
)

install(TARGETS plugin_http
            LIBRARY DESTINATION ${PLUGIN_INSTALL_DIR})
install(FILES "README_PLUGIN_HTTP"
            DESTINATION ${DOC_INSTALL_DIR})


ENDIF(PLUGIN_HTTP)

=== test/functional/gfal2/CMakeLists.txt ===
#
# compilation lines for examples


# list tests
FILE(GLOB src_gfalchecksum_test "gfal_testchecksum.c")
FILE(GLOB src_gfalstat "gfal_teststat.c")
FILE(GLOB src_gfalaccess "gfal_testaccess.c")
FILE(GLOB src_gfal_testchmod "gfal_testchmod.c")
FILE(GLOB src_gfal_checksum_tool "gfal_checksum_tool.c")
FILE(GLOB src_gfalread "gfal_testread.c")
FILE(GLOB src_gfalwrite "gfal_testwrite.c")
FILE(GLOB src_gfalrw "gfal_testrw.c")
FILE(GLOB src_gfal_test_del_nonex "gfal_test_del_nonex.c")
FILE(GLOB src_gfal_test_del "gfal_test_del.c")
FILE(GLOB src_gfal_test_mkdir_unlink "gfal_test_mkdir_unlink.c")
FILE(GLOB src_gfal_rw_full "gfal_testrw_full.c")
FILE(GLOB src_gfal_rw_seq "gfal_testrw_seq.c")
FILE(GLOB src_gfalget "gfal_testget.c")
FILE(GLOB src_gfaltestcreatedir "gfal_testcreatedir.c")
FILE(GLOB src_gfaltestrightchange "gfal_test_right_change.c")
FILE(GLOB src_gfaltestrmdirfull "gfal_test_rmdir_full.c")
FILE(GLOB src_test_readdir_full "gfal_test_readdir_full.c")
FILE(GLOB src_gfalmkdir_full "gfal_mkdir_full.c")
FILE(GLOB src_gfaltcopy "gfalt_copyfile.c")
FILE(GLOB src_gfaltcopy_cancel "gfalt_copyfile_cancel.c")
FILE(GLOB src_gfaltcopy_fts "gfalt_copyfile_fts_style.c")
FILE(GLOB src_gfaltcopy_fts_thread "gfalt_copyfile_fts_style_thread_safety.c")
FILE(GLOB src_gfaltcopy_test "gfalt_copyfile_test.c")
FILE(GLOB src_gfaltcopy_test_timeout "gfalt_copyfile_test_timeout.c")
FILE(GLOB src_gfaltcopy_test_thread_safety_timeout "gfalt_copyfile_test_thread_safey_timeout.c")
FILE(GLOB src_gfaltcopy_mkdir_test "gfalt_copyfile_mkdir_test.c")
FILE(GLOB src_gfaltcopy_perf "gfalt_copyfile_with_performance_marker.c")
FILE(GLOB src_copyfile_replace "gfalt_copyfile_replace_test.c")
FILE(GLOB src_copyfile_checksum "gfalt_copyfile_checksum_test_simple.c")
FILE(GLOB src_copyfile_checksum_user "gfalt_copyfile_checksum_test_userdefined.c")
FILE(GLOB src_testdir "gfal_testdir.c")
FILE(GLOB src_bring_online "gfal_bring_online.c")

SET(COPY_SRC "*.sh")
SET(COPY_DST "${CMAKE_CURRENT_BINARY_DIR}/")

IF (FUNCTIONAL_TESTS)


        include_directories( "${CMAKE_SOURCE_DIR}/src "  "${CMAKE_SOURCE_DIR}/src/posix/"
                    ${GLIB2_PKG_INCLUDE_DIRS} ${NETTLE_PKG_INCLUDE_DIRS} )

        add_executable(gfal_stat        ${src_gfalstat} )
        target_link_libraries(gfal_stat ${OUTPUT_NAME_MAIN} )

        add_executable(gfal_access        ${src_gfalaccess} )
        target_link_libraries(gfal_access ${OUTPUT_NAME_MAIN} )

        add_executable(gfal_checksum_tool        ${src_gfal_checksum_tool})
        target_link_libraries(gfal_checksum_tool ${OUTPUT_NAME_MAIN})
        
        FUNCTION(stat_test_all name valid)
                add_test(gfal_stat_${name} gfal_stat ${valid})
        ENDFUNCTION(stat_test_all valid)

        FUNCTION(test_gfal_test_del_nonex name dir_path)
                add_test(gfal_test_del_nonex_${name} gfal_test_del_nonex ${dir_path})
        ENDFUNCTION(test_gfal_test_del_nonex name path)        

        FUNCTION(test_gfal_test_del name dir_path)
                add_test(gfal_test_del_${name} gfal_test_del ${dir_path})
        ENDFUNCTION(test_gfal_test_del name path)        

        FUNCTION(test_gfal_test_mkdir_unlink name dir_path)
                add_test(gfal_test_mkdir_unlink_${name} gfal_test_mkdir_unlink ${dir_path})
        ENDFUNCTION(test_gfal_test_mkdir_unlink name path)        

        FUNCTION(checksum_test_all name valid)
       #         add_test(gfal_checksum_${name} gfal_checksum_test ${valid})
        ENDFUNCTION(checksum_test_all name valid)

        FUNCTION(checksum_test_simple name valid_file algo)
                add_test(gfal_checksum_simple_${name} gfal_checksum_tool ${valid_file} ${algo})
        ENDFUNCTION(checksum_test_simple name valid_file algo)
        
        FUNCTION(chmod_test_all name valid right1 right2 right3 right4)
                add_test(gfal_test_right_change_${name} gfal_test_right_change ${valid} ${right1} ${right2} ${right3} ${right4})
        ENDFUNCTION(chmod_test_all name valid right1 right2 right3 right4)        
        

        FUNCTION(rmdir_test_all name valid_dir valid_file)
                add_test(gfal_test_rmdir_full_${name} gfal_test_rmdir_full ${valid_dir} ${valid_file} )
        ENDFUNCTION(rmdir_test_all name valid right1 right2 right3 right4)        
        
        FUNCTION(test_readdir_full name valid)
                add_test(gfal_test_readdir_full_${name} gfal_test_readdir_full ${valid})
        ENDFUNCTION(test_readdir_full valid)        

        FUNCTION(rwt_test_all name path size)
                add_test(gfal_rw_size_${name} gfal_rw_full ${path} ${size})
        ENDFUNCTION(rwt_test_all name path size)
        
        FUNCTION(rwt_test_seq name path size size_read)
                add_test(gfal_rw_seq_${name} gfal_rw_seq ${path} ${size} ${size_read})                
        ENDFUNCTION(rwt_test_seq name path size size_read)
                
        add_executable(gfal_read        ${src_gfalread} )
        target_link_libraries(gfal_read ${OUTPUT_NAME_MAIN} )
        
        add_executable(gfal_write        ${src_gfalwrite} )
        target_link_libraries(gfal_write ${OUTPUT_NAME_MAIN} )        

        add_executable(gfal_rw        ${src_gfalrw} )
        target_link_libraries(gfal_rw ${OUTPUT_NAME_MAIN} )

        add_executable(gfal_test_del_nonex   ${src_gfal_test_del_nonex} ${src_lib_test})
        target_link_libraries(gfal_test_del_nonex ${OUTPUT_NAME_MAIN} )

        add_executable(gfal_test_del   ${src_gfal_test_del} ${src_lib_test})
        target_link_libraries(gfal_test_del ${OUTPUT_NAME_MAIN} )
        
        add_executable(gfal_test_mkdir_unlink   ${src_gfal_test_mkdir_unlink} ${src_lib_test})
        target_link_libraries(gfal_test_mkdir_unlink ${OUTPUT_NAME_MAIN} )

        add_executable(gfal_rw_full        ${src_gfal_rw_full} )
        target_link_libraries(gfal_rw_full ${OUTPUT_NAME_MAIN} )        
        
        add_executable(gfal_rw_seq        ${src_gfal_rw_seq} )
        target_link_libraries(gfal_rw_seq ${OUTPUT_NAME_MAIN} )                
        
        add_executable(gfal_testget        ${src_gfalget} )
        target_link_libraries(gfal_testget ${OUTPUT_NAME_MAIN} )
        
        add_executable(gfal_testchmod        ${src_gfal_testchmod} )
        target_link_libraries(gfal_testchmod ${OUTPUT_NAME_MAIN} )        

        add_executable(gfal_createdir        ${src_gfaltestcreatedir} )
        target_link_libraries(gfal_createdir ${OUTPUT_NAME_MAIN} )
        

        add_executable(gfal_test_mkdir_full        ${src_gfalmkdir_full} )
        target_link_libraries(gfal_test_mkdir_full ${OUTPUT_NAME_MAIN} ${GLIB2_PKG_LIBRARIES})
        
        add_executable(gfal_test_right_change ${src_gfaltestrightchange})
        target_link_libraries(gfal_test_right_change ${OUTPUT_NAME_MAIN} ${GLIB2_PKG_LIBRARIES})        
        
        add_executable(gfal_test_rmdir_full ${src_gfaltestrmdirfull})
        target_link_libraries(gfal_test_rmdir_full ${OUTPUT_NAME_MAIN} ${GLIB2_PKG_LIBRARIES})        

        add_executable(gfal_test_readdir_full        ${src_test_readdir_full} )
        target_link_libraries(gfal_test_readdir_full ${OUTPUT_NAME_MAIN} ${GLIB2_PKG_LIBRARIES})

		add_executable(gfal_ls ${src_testdir})
		target_link_libraries(gfal_ls ${OUTPUT_NAME_MAIN} ${GLIB2_PKG_LIBRARIES})
   
	    add_executable(gfal_bring_online ${src_bring_online})
	    target_link_libraries(gfal_bring_online ${OUTPUT_NAME_MAIN} ${GLIB2_PKG_LIBRARIES})

        FUNCTION(mkdir_test_all name prefix)
                add_test(gfal_mkdir_full_${name} gfal_test_mkdir_full ${prefix})
        ENDFUNCTION(mkdir_test_all name prefix)        
        
        IF (MAIN_TRANSFER)

                add_executable(gfal_copyfile ${src_gfaltcopy} )
                target_link_libraries(gfal_copyfile ${OUTPUT_NAME_TRANSFER} ${OUTPUT_NAME_MAIN})
                
                add_executable(gfal_copyfile_cancel ${src_gfaltcopy_cancel} )
                target_link_libraries(gfal_copyfile_cancel ${OUTPUT_NAME_TRANSFER} ${OUTPUT_NAME_MAIN} ${CMAKE_THREAD_LIBS_INIT} pthread)

                add_executable(gfal_copyfile_fts ${src_gfaltcopy_fts} )
                target_link_libraries(gfal_copyfile_fts ${OUTPUT_NAME_TRANSFER} ${OUTPUT_NAME_MAIN})

                add_executable(gfal_copyfile_fts_thread ${src_gfaltcopy_fts_thread} ${src_lib_test})
                target_link_libraries(gfal_copyfile_fts_thread ${OUTPUT_NAME_TRANSFER} ${OUTPUT_NAME_MAIN})

                add_executable(gfal_copyfile_perf ${src_gfaltcopy_perf} )
                target_link_libraries(gfal_copyfile_perf ${OUTPUT_NAME_TRANSFER} ${OUTPUT_NAME_MAIN})
                
                add_executable(gfal_copyfile_test ${src_gfaltcopy_test} ${src_lib_test})
                target_link_libraries(gfal_copyfile_test ${OUTPUT_NAME_TRANSFER} ${OUTPUT_NAME_MAIN})

                add_executable(gfal_copyfile_thead_safety_test ${src_gfaltcopy_test_thread_safety_timeout} ${src_lib_test})
                target_link_libraries(gfal_copyfile_thead_safety_test ${OUTPUT_NAME_TRANSFER} ${OUTPUT_NAME_MAIN})

                add_executable(gfal_copyfile_test_timeout ${src_gfaltcopy_test_timeout} ${src_lib_test})
                target_link_libraries(gfal_copyfile_test_timeout ${OUTPUT_NAME_TRANSFER} ${OUTPUT_NAME_MAIN})
                
                add_executable(gfal_copyfile_mkdir_test ${src_gfaltcopy_mkdir_test} ${src_lib_test})
                target_link_libraries(gfal_copyfile_mkdir_test ${OUTPUT_NAME_TRANSFER} ${OUTPUT_NAME_MAIN})                
                
                add_executable(copyfile_replace ${src_copyfile_replace} ${src_lib_test})
                target_link_libraries(copyfile_replace ${OUTPUT_NAME_TRANSFER} ${OUTPUT_NAME_MAIN})

                add_executable(copyfile_checksum ${src_copyfile_checksum} ${src_lib_test})
                target_link_libraries(copyfile_checksum ${OUTPUT_NAME_TRANSFER} ${OUTPUT_NAME_MAIN})

                add_executable(copyfile_checksum_user ${src_copyfile_checksum_user} ${src_lib_test})
                target_link_libraries(copyfile_checksum_user ${OUTPUT_NAME_TRANSFER} ${OUTPUT_NAME_MAIN})
                
#                copy_files(${COPY_SRC} ${COPY_DST})
#                add_test(functional_copyfile gfal2_copyfile.sh)
#                add_test(functional_copyfile_srm gfal2_copyfile_srm.sh)
                
        FUNCTION(copy_file_test_full name src_file dir_src)
                add_test(copyfile_checksum_${name} copyfile_checksum ${src_file} ${dir_src})
                add_test(copyfile_checksum_user_${name} copyfile_checksum_user ${src_file} ${dir_src})
                add_test(copyfile_replace_${name} copyfile_replace ${src_file} ${dir_src})
                add_test(copyfile_test_${name} gfal_copyfile_test ${src_file} ${dir_src})
                add_test(copyfile_test_mkdir_${name} gfal_copyfile_mkdir_test ${src_file} ${dir_src})                
        ENDFUNCTION(copy_file_test_full name dir_src)


        FUNCTION(copy_file_test_simple name src_file dir_src)
                add_test(copyfile_test_${name} gfal_copyfile_test ${src_file} ${dir_src})
        ENDFUNCTION(copy_file_test_simple name src_file dir_src)


        FUNCTION(copy_file_test_timeout name src_file dir_src)
                add_test(copy_file_test_timeout_${name} gfal_copyfile_test_timeout ${src_file} ${dir_src})
        ENDFUNCTION(copy_file_test_timeout name src_file dir_src)

        ENDIF (MAIN_TRANSFER)

        include(functional-test-parameters.cmake)        
        
ENDIF  (FUNCTIONAL_TESTS)

=== debian/changelog ===
gfal2 (2.2.1-2) unstable; urgency=low

  * Workaraond for no dirent d_off on hurd and kfreebsd

 -- Mattias Ellert <mattias.ellert@fysast.uu.se>  Sun, 05 May 2013 15:50:21 +0200

gfal2 (2.2.1-1) unstable; urgency=low

  * New upstream release
  * Workaround missing ECOMM on hurd and kfreebsd

 -- Mattias Ellert <mattias.ellert@fysast.uu.se>  Fri, 03 May 2013 18:55:59 +0200

=== debian/control ===
Source: gfal2
Priority: optional
Maintainer: Mattias Ellert <mattias.ellert@fysast.uu.se>
Build-Depends: debhelper (>= 8.0.0), cmake, doxygen, libglib2.0-dev, libglibmm-2.4-dev, libattr1-dev, libldap2-dev, uuid-dev, liblfc-dev, libdpm-dev, srm-ifce-dev (>= 1.15.0), dcap-dev, libglobus-gass-copy-dev, pkg-config
Standards-Version: 3.9.4
Section: net
Homepage: https://svnweb.cern.ch/trac/lcgutil/wiki/gfal2

Package: gfal2
Architecture: any
Depends:  libgfal2-2 (= ${binary:Version}), libgfal-transfer2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: gfal2-plugin-lfc (= ${binary:Version}), gfal2-plugin-rfio (= ${binary:Version}), gfal2-plugin-dcap (= ${binary:Version}), gfal2-plugin-srm (= ${binary:Version}), gfal2-plugin-gridftp (= ${binary:Version})
Description: Grid file access library 2.0
 GFAL 2.0 offers an a single and simple POSIX-like API for the file
 operations in grids and cloud environments. The set of supported
 protocols depends on the gfal2 installed plugins.

Package: libgfal2-2
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Core of the Grid File access Library 2.0
 The main library of gfal2. The gfal protocol support relies on a
 plugin system.

Package: libgfal-transfer2
Section: libs
Architecture: any
Depends: libgfal2-2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: File Transfer logic of gfal2
 gfal-transfer is the high level API for file transfer operations in
 gfal2. It supports third-party copy.

Package: libgfal2-dev
Section: libdevel
Architecture: any
Depends: libgfal2-2 (= ${binary:Version}), libgfal-transfer2 (= ${binary:Version}), libglib2.0-dev, libattr1-dev, ${misc:Depends}
Description: Development files of gfal2
 Development files for gfal2

Package: gfal2-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Documentation for gfal2
 Documentation, doxygen and examples of gfal2.

Package: gfal2-plugin-lfc
Architecture: any
Depends: libgfal2-2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Provide the lfc access for gfal2
 Provide the lfc support (LFN://) for gfal2. The LFC plugin allows
 read-only POSIX operations for the LFC catalog.

Package: gfal2-plugin-rfio
Architecture: any
Depends: libgfal2-2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Provide the rfio access for gfal2
 Provide the rfio support (RFIO://) for gfal2. The rfio plugin
 provides the POSIX operations for the rfio URLs, the rfio protocol is
 used on the DPM and on the Castor storage systems.

Package: gfal2-plugin-dcap
Architecture: any
Depends: libgfal2-2 (= ${binary:Version}), dcap-tunnel-gsi, ${shlibs:Depends}, ${misc:Depends}
Description: Provide the dcap access for gfal2
 Provide the dcap support (GSIDCAP://, DCAP://) for gfal2. The dcap
 plugin provides the POSIX operations for the dcap URLs, the dcap
 protocol is used on the DCACHE storage system

Package: gfal2-plugin-srm
Architecture: any
Depends: libgfal2-2 (= ${binary:Version}), libgfal-srm-ifce1 (>= 1.15.0), ${shlibs:Depends}, ${misc:Depends}
Description: Provide the srm access for gfal2
 Provide the srm support (SRM://) for gfal2. The srm plugin provides
 the POSIX operations and the third party transfer support on the SRM
 URLs.

Package: gfal2-plugin-gridftp
Architecture: any
Depends: libgfal2-2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Provide the gridftp access for gfal2
 Provide the gridftp support (GSIFTP://) for gfal2. The gridftp plugin
 provides the POSIX operations and the third party transfer support on
 the GSIFTP URLs.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

-include /usr/share/dpkg/buildflags.mk

CFLAGS += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

export CFLAGS CXXFLAGS LDFLAGS

%:
	dh $@ 

override_dh_auto_configure:
	dh_auto_configure -- -DLIB_SUFFIX="" -DSYSCONF_INSTALL_DIR=/etc

override_dh_auto_build:
	dh_auto_build -- all doc

override_dh_install:
	mkdir -p debian/gfal2-doc/usr/share/doc/gfal2-doc
	mv debian/tmp/usr/share/doc/gfal2/examples \
	   debian/tmp/usr/share/doc/gfal2/html \
	   debian/gfal2-doc/usr/share/doc/gfal2-doc
	rm -rf debian/tmp/usr/share/doc
	dh_install --fail-missing
